// This is a generated file, modify: generate/templates/class_content.cc.
#include <nan.h>
#include <string.h>
#include <chrono>
#include <thread>

extern "C" {
#include <git2.h>
}

#include "../include/functions/copy.h"
#include "../include/macros.h"
#include "../include/config_entry.h"


#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitConfigEntry::GitConfigEntry(git_config_entry *raw, bool selfFreeing)
{
  this->raw = raw;
  this->selfFreeing = selfFreeing;
}

GitConfigEntry::~GitConfigEntry()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.

}

void GitConfigEntry::InitializeComponent(Handle<v8::Object> target)
{
  NanScope();

  Local<FunctionTemplate> tpl = NanNew<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(NanNew<String>("ConfigEntry"));

  NODE_SET_PROTOTYPE_METHOD(tpl, "name", Name);
  NODE_SET_PROTOTYPE_METHOD(tpl, "value", Value);
  NODE_SET_PROTOTYPE_METHOD(tpl, "level", Level);

  Local<Function> _constructor_template = tpl->GetFunction();
  NanAssignPersistent(constructor_template, _constructor_template);
  target->Set(NanNew<String>("ConfigEntry"), _constructor_template);
}

NAN_METHOD(GitConfigEntry::JSNewFunction)
{
  NanScope();

  if (args.Length() == 0 || !args[0]->IsExternal()) {
    return NanThrowError("A new GitConfigEntry cannot be instantiated.");
  }

  GitConfigEntry* object = new GitConfigEntry(static_cast<git_config_entry *>(Handle<External>::Cast(args[0])->Value()), args[1]->BooleanValue());
  object->Wrap(args.This());

  NanReturnValue(args.This());
}

Handle<v8::Value> GitConfigEntry::New(void *raw, bool selfFreeing)
{
  NanEscapableScope();
  Handle<v8::Value> argv[2] = { NanNew<External>((void *)raw), NanNew<Boolean>(selfFreeing) };
  return NanEscapeScope(NanNew<Function>(GitConfigEntry::constructor_template)->NewInstance(2, argv));
}

git_config_entry *GitConfigEntry::GetValue()
{
  return this->raw;
}

git_config_entry **GitConfigEntry::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitConfigEntry::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitConfigEntry::Name)
{
  NanScope();
  Handle<v8::Value> to;

  const char *
  name =
    ObjectWrap::Unwrap<GitConfigEntry>(args.This())->GetValue()->name;
// start convert_to_v8 block
  if (name) {
    to = NanNew<String>(name);
  } else {
    to = NanNull();
  }

  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitConfigEntry::Value)
{
  NanScope();
  Handle<v8::Value> to;

  const char *
  value =
    ObjectWrap::Unwrap<GitConfigEntry>(args.This())->GetValue()->value;
// start convert_to_v8 block
  if (value) {
    to = NanNew<String>(value);
  } else {
    to = NanNull();
  }

  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitConfigEntry::Level)
{
  NanScope();
  Handle<v8::Value> to;

  git_config_level_t
  level =
    ObjectWrap::Unwrap<GitConfigEntry>(args.This())->GetValue()->level;
// start convert_to_v8 block
  to = NanNew<Number>(level);
  // end convert_to_v8 block
  NanReturnValue(to);
}
Persistent<Function> GitConfigEntry::constructor_template;
